import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Random;

public class GenRange {

    public final static int SEED = "halfway-there".hashCode();
    public final static Random rng = new Random(SEED);
    public final static int ARGS_COUNT = 2;
    
    public static void main(String[] args) {
        if (args.length < ARGS_COUNT) {
            throw new IllegalArgumentException(
                    String.format("Expected %d arguments, but got %d instead", ARGS_COUNT, args.length));
        }
        rng.setSeed(Arrays.hashCode(args));
        long start = Long.parseLong(args[0]);
        long finish = Long.parseLong(args[1]);
        generateRange(start, finish);
    }

    static void generateRange(long start, long finish) {
        try (PrintWriter out = new PrintWriter(System.out)) {
            int t = (int) (Math.abs(start - finish) + 1);
            out.println(t);
            for (int i = 0; i < t; i++) {
                out.println(start);
                if (start < finish) {
                    start++;
                } else {
                    start--;
                }
            }
        }
    }
}
