import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.StringTokenizer;

public class multiprocessor_va_tl_v2 {
    public static void main(String[] args) {
        new multiprocessor_va_tl_v2().run();
    }

    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public class Equation {
        String variable;
        int value;

        public Equation(String variable, int value) {
            this.variable = variable;
            this.value = value;
        }
    }

    public void solve() throws IOException {
        int n = nextInt();
        Equation[][] programs = new Equation[n][];

        for (int i = 0; i < n; i++) {
            int k = nextInt();
            programs[i] = new Equation[k];
            for (int j = 0; j < k; j++) {
                String token = nextToken();
                String[] parts = token.split("=");
                programs[i][k - j - 1] = new Equation(parts[0], Integer.parseInt(parts[1]));
            }
        }

        HashMap<String, Integer> target = new HashMap<>();

        int k = nextInt();
        for (int i = 0; i < k; i++) {
            target.put(nextToken(), nextInt());
        }

        int[] eid = new int[programs.length];
        int finished = 0;

        ArrayList<Integer> answer = new ArrayList<>();

        while (finished < programs.length) {
            int p = -1;
            for (int i = 0; i < programs.length; i++) {
                if (eid[i] == programs[i].length) {
                    continue;
                }
                Equation variable = programs[i][eid[i]];
                if (!target.containsKey(variable.variable)) {
                    p = i;
                } else if (target.get(variable.variable).equals(variable.value)) {
                    p = i;
                }
            }
            if (p == -1) {
                break;
            }

            target.remove(programs[p][eid[p]].variable);
            eid[p]++;
            answer.add(p);
            if (eid[p] == programs[p].length) {
                finished++;
            }
        }

        if (target.size() == 0) {
            out.println("Yes");
            for (int i = answer.size() - 1; i >= 0; i--) {
                out.print((answer.get(i) + 1) + " ");
            }
        } else {
            out.println("No");
        }

    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
