#include <iostream>
#include <regex>
#include "testlib.h"

void check_date (std::string str) {
    ensuref (str.size() >= 4, "Too short string: %s", str.c_str());

    std::regex r("^(AD [1-9]\\d{0,3})|([1-9]\\d{0,3} BC)");
    ensuref (regex_match (str,r), "String `%s` does not match regexp", str.c_str());
}
  
int main (int argc, char* argv[]) {
    registerValidation(argc, argv);
    check_date (inf.readLine("[A-Z0-9\\ ]{1,100}", "date 1"));
    check_date (inf.readLine("[A-Z0-9\\ ]{1,100}", "date 2"));

    inf.readEof();
}
