import ru.ifmo.testlib.Checker;
import ru.ifmo.testlib.CheckerFramework;
import ru.ifmo.testlib.InStream;
import ru.ifmo.testlib.Outcome;

import java.util.HashSet;
import java.util.Objects;
import java.util.Set;
import java.util.stream.Stream;

import static ru.ifmo.testlib.Outcome.Type.*;

/**
 * @author Georgiy Korneev (kgeorgiy@kgeorgiy.info)
 */
public class Check implements Checker {
    public Outcome test(InStream inf, InStream ouf, InStream ans) {
        final int n = inf.nextInt();
        final int m = inf.nextInt();
        int c = inf.nextInt();

        final long jury = check(ans, FAIL, n, m, c);
        final long user = check(ouf, WA, n, m, c);
        if (user != jury) {
            return new Outcome(user > jury ? WA : FAIL, String.format("Expected %d, found %d", jury, user));
        } else {
            return new Outcome(OK, String.format("%d", jury));
        }       
    }

    private long check(final InStream f, final Outcome.Type o, final long n, final long m, final long c) {
        long M = f.nextInt();
        long C = f.nextInt();
        if (M < 0 || 2_000_000 < M) {
            throw new Outcome(o, String.format("Invalid M: %d", M));
        }
        if (C < 0 || 6_000_000 < C) {
            throw new Outcome(o, String.format("Invalid C: %d", C));
        }
        return Math.abs(M * m + C * c - n);
    }

    public static void main(String[] args) {
        CheckerFramework.main(args);
    }
}
