private fun String.getOrEnd(index: Int) = getOrElse(index) { '$' }

private fun solve(s: List<String>, index: Int, k: Int) : Pair<Int, Int> {
    if (s.size == 1) return 0 to 1
    val splitIndex = (index until Int.MAX_VALUE).first { i -> s.any { it.getOrEnd(i) != s[0].getOrEnd(i) } }
    val parts = s.groupBy { it.getOrEnd(splitIndex) }.map { solve(it.value, index + 1, k) }
    val ops = parts.sumOf { it.first }
    val rems = parts.sumOf { it.second }
    if (rems <= k) {
        return ops to rems
    } else {
        val remsSum = IntArray(parts.size) { parts[it].second }.apply { sort() }.runningFold(0, Int::plus)
        val batchSize = remsSum.indexOfFirst { it > k } - 1
        return ops + (parts.size - batchSize) to remsSum[batchSize]
    }
}

fun main() {
    val (n, k) = readInts()
    val s = List(n) { readLn() }
    val (ops, rem) = solve(s, 0, k)
    if (rem > k) throw AssertionError()
    println(ops + minOf(rem, 1))
}

private fun readLn() = readLine()!!
private fun readInt() = readLn().toInt()
private fun readLongs() = readStrings().map { it.toLong() }
private fun readStrings() = readLn().split(" ")
private fun readInts() = readStrings().map { it.toInt() }