#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

int main(int argc, char **argv) {
  registerGen(argc, argv, 1);
  int start = atoi(argv[1]);
  int maxn = atoi(argv[2]);
  int maxm = atoi(argv[3]);
  auto PrintRandom = [&](int n, int m, int limit) {
    set<int> s;
    while ((int) s.size() < n) {
      s.insert(rnd.next(0, limit));
    }
    cout << n << " " << m << '\n';
    auto iter = s.begin();
    for (int i = 0; i < n; i++) {
      if (i > 0) {
        cout << " ";
      }
      cout << *iter;
      ++iter;
    }
    cout << '\n';
  };
  auto PrintStep = [&](int n, int m, int limit) {
    vector<int> a(n);
    a[0] = rnd.next(0, limit);
    for (int i = 1; i < n; i++) {
      a[i] = a[i - 1] + rnd.next(1, limit);
      if (a[i] > maxm) {
        n = i;
        break;
      }
    }
    cout << n << " " << m << '\n';
    for (int i = 0; i < n; i++) {
      if (i > 0) {
        cout << " ";
      }
      cout << a[i];
    }
    cout << '\n';
  };
  auto PrintStepSkip = [&](int n, int m, int limit) {
    vector<int> a(n);
    a[0] = rnd.next(0, limit);
    for (int i = 1; i < n; i++) {
      a[i] = a[i - 1] + (i % 2 == 1 ? rnd.next(1, m) : rnd.next(m, limit));
      if (a[i] > maxm) {
        n = i;
        break;
      }
    }
    cout << n << " " << m << '\n';
    for (int i = 0; i < n; i++) {
      if (i > 0) {
        cout << " ";
      }
      cout << a[i];
    }
    cout << '\n';
  };
  int tt = maxn;
  while (tt > 0) {
    for (int rot = 0; rot < 2; rot++) {
      startTest(start++);
      cout << tt << '\n';
      vector<int> divs(tt - 1);
      for (int i = 0; i < tt - 1; i++) divs[i] = rnd.next(0, maxn - tt);
      sort(divs.begin(), divs.end());
      divs.push_back(maxn - tt);
      divs.insert(divs.begin(), 0);
      for (int i = 0; i < tt; i++) {
        int n = divs[i + 1] - divs[i] + 1;
        int limit = rnd.next(n - 1, rot == 0 ? maxn : maxm);
        int m = max(1, (int) exp(rnd.next() * log(limit)));
        PrintRandom(n, m, limit);
      }
    }
    tt /= 2;
  }
  {
    startTest(start++);
    cout << 1 << '\n';
    PrintRandom(maxn, 1, maxn - 1);
  }
  {
    startTest(start++);
    cout << 4 << '\n';
    cout << 1 << " " << 1 << '\n';
    cout << 0 << '\n';
    cout << 1 << " " << 1000000000 << '\n';
    cout << 0 << '\n';
    cout << 1 << " " << 1 << '\n';
    cout << 1000000000 << '\n';
    cout << 1 << " " << 1000000000 << '\n';
    cout << 1000000000 << '\n';
  }
  for (int rot = 0; rot < 2; rot++) {
    for (double x : vector<double> {2, 1.5, 1.3, 1.1, 1.01, 1}) {
      tt = maxn / 12;
      while (tt > 0) {
        startTest(start++);
        cout << tt << '\n';
        vector<int> divs(tt - 1);
        for (int i = 0; i < tt - 1; i++) divs[i] = rnd.next(0, maxn - tt);
        sort(divs.begin(), divs.end());
        divs.push_back(maxn - tt);
        divs.insert(divs.begin(), 0);
        for (int i = 0; i < tt; i++) {
          int n = divs[i + 1] - divs[i] + 1;
          int m = rnd.next(1, maxm / n / 2);
          if (rot == 0) {
            PrintStep(n, m, (int) (x * m));
          } else {
            PrintStepSkip(n, m, (int) (x * m));
          }
        }
        tt /= 12;
      }
    }
  }
  for (int x : {maxm, maxm / 10, maxn, 10, 1}) {
    startTest(start++);
    cout << 1 << '\n';
    PrintRandom(maxn, x, maxm);
  }
  return 0;
}
