import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.Random;

public class GenTwoPrimes {

    public final static int SEED = "halfway-there".hashCode();
    public final static Random rng = new Random(SEED);
    public final static int ARGS_COUNT = 2;
    
    public static void main(String[] args) {
        if (args.length < ARGS_COUNT) {
            throw new IllegalArgumentException(
                    String.format("Expected %d arguments, but got %d instead", ARGS_COUNT, args.length));
        }
        rng.setSeed(Arrays.hashCode(args));
        int tests = Integer.parseInt(args[0]);
        long limit = Long.parseLong(args[1]);
        generateRandom(tests, limit);
    }

    static void generateRandom(int t, long limit) {
        try (PrintWriter out = new PrintWriter(System.out)) {
            out.println(t);
            for (int i = 0; i < t; i++) {
                int bitLength = (63 - Long.numberOfLeadingZeros(limit)) / 2;
                int p1 = BigInteger.probablePrime(bitLength, rng).intValue();
                int p2 = BigInteger.probablePrime(bitLength, rng).intValue();
                out.println((long) p1 * p2);
            }
        }
    }
}
