#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {
    setName("Interactor for 'Imprecise Permutation Sort' problem.");
    registerInteraction(argc, argv);
   	int const EPSILON_INVERSE = 100;

    int n = inf.readInt();
    vector<int> p = inf.readInts(n);
    int inPlace = 0;
    for (int i = 0; i < n; i++) {
    	if (p[i] == i + 1) inPlace++;
    }

    cout << n << endl;

	int queries = 0;
    while (true) {
    	char command = ouf.readToken("[CS]")[0];
    	int i = ouf.readInt(1, n, "i") - 1;
    	int j = ouf.readInt(1, n, "j") - 1;
    	queries++;
    	if (command == 'C') {
    		int a = p[i], b = p[j];
    		int cmp = (EPSILON_INVERSE * abs(a - b) <= max(a, b)) ? 0 : (a < b ? -1 : 1);
    		cout << cmp << endl;
    	} else {
	    	if (p[i] == i + 1) inPlace--;
	    	if (p[j] == j + 1) inPlace--;
    		swap(p[i], p[j]);
	    	if (p[i] == i + 1) inPlace++;
	    	if (p[j] == j + 1) inPlace++;
    		int res = (inPlace == n) ? 1 : 0;
    		cout << res << endl;
    		if (res == 1) break;
    	}
    }
    tout << queries << endl;
}
