import java.io.*;
import java.util.*;

public class multiprocessor_va_tl {
    public static void main(String[] args) {
        new multiprocessor_va_tl().run();
    }

    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public class Equation {
        String variable;
        int value;

        public Equation(String variable, int value) {
            this.variable = variable;
            this.value = value;
        }
    }

    public void solve() throws IOException {
        int n = nextInt();
        Equation[][] programs = new Equation[n][];

        for (int i = 0; i < n; i++) {
            int k = nextInt();
            programs[i] = new Equation[k];
            for (int j = 0; j < k; j++) {
                String token = nextToken();
                String[] parts = token.split("=");
                programs[i][k - j - 1] = new Equation(parts[0], Integer.parseInt(parts[1]));
            }
        }

        HashMap<String, Integer> target = new HashMap<>();

        int k = nextInt();
        for (int i = 0; i < k; i++) {
            target.put(nextToken(), nextInt());
        }

        int[] eid = new int[programs.length];
        int finished = 0;

        ArrayList<Integer> answer = new ArrayList<>();

        boolean changed = true;
        int incs = 0;
        while (target.size() > 0 && changed && finished < programs.length) {
            changed = false;
            for (int i = 0; i < programs.length; i++) {
                if (eid[i] == programs[i].length) {
                    continue;
                }
                while (eid[i] < programs[i].length) {
                    Equation variable = programs[i][eid[i]];
                    if (!target.containsKey(variable.variable)) {
                        eid[i]++;
                        answer.add(i);
                    } else if (target.get(variable.variable).equals(variable.value)) {
                        target.remove(variable.variable);
                        changed = true;
                        eid[i]++;
                        answer.add(i);
                    } else {
                        break;
                    }
                }
                if (eid[i] == programs[i].length) {
                    finished++;
                }
            }
        }

        for (int i = 0; i < n; i++) {
            while (eid[i] != programs[i].length) {
                answer.add(i);
                eid[i]++;
            }
        }

        if (target.size() == 0) {
            out.println("Yes");
            for (int i = answer.size() - 1; i >= 0; i--) {
                out.print((answer.get(i) + 1) + " ");
            }
        } else {
            out.println("No");
        }

    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
