#include "testlib.h"
#include <functional>
#include <cassert>

using namespace std;

int const MAXSUM = 300000;

struct vertex {
	int white;
	int black;
};

struct test {
	vector<vertex> a;
};

int main(int argc, char **argv) {
	registerGen(argc, argv, 1);
	int maxN = atoi(argv[1]);
	vector<test> tests;
	int sumN = 0;
	for (int n = maxN; n >= 1; n--) {
		vector<vertex> a(n);
		function<void(int)> gen = [&](int v) {
			if (sumN > MAXSUM) return;
			if (v == n) {
				tests.push_back({a});
				sumN += n;
				return;
			}
			for (int w = 0; w < n; w++) {
				for (int b = 0; b < n; b++) {
					a[v].white = w;
					a[v].black = b;
					gen(v + 1);
				}
			}
		};
		gen(0);
	}
	cerr << "Sum of N = " << sumN << endl;
	if (sumN > MAXSUM) {
		while (sumN > MAXSUM) {
			auto &e = tests.back();
			if ((int) e.a.size() == maxN) break;
			sumN -= (int) e.a.size();
			tests.pop_back();
		}
		cerr << "After deleting small: Sum of N = " << sumN << endl;
		if (sumN > MAXSUM) {
			shuffle(tests.begin(), tests.end());
			while (sumN > MAXSUM) {
				auto &e = tests.back();
				sumN -= (int) e.a.size();
				tests.pop_back();
			}
			cerr << "Shuffled, after deleting large: Sum of N = " << sumN << endl;
		}
	}
	reverse(tests.begin(), tests.end());
	cout << tests.size() << '\n';
	for (auto &t : tests) {
		cout << t.a.size() << '\n';
		for (auto &v : t.a) {
			cout << v.white << ' ' << v.black << '\n';
		}
	}
}
